/* 
 * This program is written by 
 *               
 *                          Murtaza Amiji
 *		Department Of ELectrical & Computer Engineering,
 *		     Worcester Polytechnic Institute,
 *		            Worcester, MA.
 *                      E-Mail: murti@ece.wpi.edu
 *               Personal Homepage: http://www.wpi.edu/~murti
 *                   ECE Homepage: http://ece.wpi.edu
 *
 *
 * Copyright (c) 1995-96 Worcester Polytechnic Institute. 
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for non commericial purpose, provided that 
 * the above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 * 
 * IN NO EVENT SHALL WORCESTER POLYTECHNIC INSTITUTE BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF WORCESTER 
 * POLYTECHNIC INSTITUTE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * WORCESTER POLYTECHNIC INSTITUTE SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND WORCESTER POLYTECHNIC INSTITUTE HAS NO OBLIGATION 
 * TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/soundcard.h>
#include <linux/time.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include "adpcm.h"

#define FRAGMENT 128
#define AUDIO "/dev/dsp"
#define TRUE 1
#define FALSE 0
#define SERVER_RESPONSE "Connection established to the server."
#define CLIENT_RESPONSE "Connection established to the client."
#define DAEMON_RESPONSE "Connected to the party's daemon. Waiting for the party to launch E-Phone..."
#define EPHONE_SERVER "./ephone_server"

struct adpcm_state code;
struct adpcm_state decode;
static int compressed_size = FRAGMENT/2;
int bits_per_sample = 16;
int dma_buffer_size = 0x00020007;
static short record_buffer[FRAGMENT];
static short play_buffer[FRAGMENT];
static float squelch = 0;
static int count = 0, sock = -1, client_socket = -1, server_socket = -1 ,audio = -1, audio_rd = -1, audio_wr = -1;
static float average_amplitude;
static int serv_len, cli_len, daemon_len;
static struct sockaddr_in server, ext_server, ext_client, ext_daemon;
static char receive_buffer[FRAGMENT]; 
static char transmit_buffer[FRAGMENT];
static float cutoff_amplitude;
static float total_average_amplitude;
static int steps = 0;
static char hostname[512];
static char compressed_buffer[FRAGMENT];
static int RECEIVING = FALSE, TRANSMITTING = FALSE;
struct queueNode
{
   char data[FRAGMENT];
   struct queueNode *nextPtr;
};

typedef struct queueNode QUEUENODE;
typedef QUEUENODE *QUEUENODEPTR;
static QUEUENODEPTR headPtr = NULL, tailPtr = NULL;

void enqueue(QUEUENODEPTR *, QUEUENODEPTR *);
void dequeue(QUEUENODEPTR *, QUEUENODEPTR *);
int isEmpty(QUEUENODEPTR);
void message(char *);
int threshold(void);
int RecordPlay_FullDuplex(void);
int open_recording(void);
int open_playback(void);
int network_connection(void);
int connect_to_server();
int squelch_buffer(int );
int DSP_config(void);
int Init_Soundcard(void);
int receive_audio(void);
int transmit_audio(void);













